// MuleToolBarCtrl.cpp : implementation file
///////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MuleToolbarCtrl.h"
#include "emule.h"
#include "EnBitmap.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// CMuleToolbarCtrl

IMPLEMENT_DYNAMIC(CMuleToolbarCtrl, CToolBarCtrl)
CMuleToolbarCtrl::CMuleToolbarCtrl()
{
	m_bUseSpeedMeter = false;
	m_iLastPressedButton = -1;
}

CMuleToolbarCtrl::~CMuleToolbarCtrl()
{
}


BEGIN_MESSAGE_MAP(CMuleToolbarCtrl, CToolBarCtrl)
	ON_WM_SIZE()
	ON_NOTIFY_REFLECT(NM_RCLICK, OnNMRclick)
	ON_NOTIFY_REFLECT(TBN_QUERYDELETE, OnTbnQueryDelete)
	ON_NOTIFY_REFLECT(TBN_QUERYINSERT, OnTbnQueryInsert)
	ON_NOTIFY_REFLECT(TBN_GETBUTTONINFO, OnTbnGetButtonInfo)
	ON_NOTIFY_REFLECT(TBN_TOOLBARCHANGE, OnTbnToolbarChange)
END_MESSAGE_MAP()


void CMuleToolbarCtrl::Init(void)
{
	ModifyStyle(0, TBSTYLE_FLAT | CCS_ADJUSTABLE | TBSTYLE_TRANSPARENT | CCS_NODIVIDER);
	ChangeToolbarBitmap(theApp.glob_prefs->GetToolbarBitmapSettings(), false);
	// add button-text:
	char cButtonStrings[2000];
	int lLen, lLen2;
	
	strcpy(cButtonStrings, GetResString(IDS_MAIN_BTN_CONNECT));
	lLen = strlen(GetResString(IDS_MAIN_BTN_CONNECT)) + 1;

	lLen2 = strlen(GetResString(IDS_EM_SERVER)) + 1;
	memcpy(cButtonStrings+lLen, GetResString(IDS_EM_SERVER), lLen2);
	lLen += lLen2;

	lLen2 = strlen(GetResString(IDS_EM_TRANS)) + 1;
	memcpy(cButtonStrings+lLen, GetResString(IDS_EM_TRANS), lLen2);
	lLen += lLen2;

	lLen2 = strlen(GetResString(IDS_EM_SEARCH)) + 1;
	memcpy(cButtonStrings+lLen, GetResString(IDS_EM_SEARCH), lLen2);
	lLen += lLen2;

	lLen2 = strlen(GetResString(IDS_EM_FILES)) + 1;
	memcpy(cButtonStrings+lLen, GetResString(IDS_EM_FILES), lLen2);
	lLen += lLen2;

	lLen2 = strlen(GetResString(IDS_EM_MESSAGES)) + 1;
	memcpy(cButtonStrings+lLen, GetResString(IDS_EM_MESSAGES), lLen2);
	lLen += lLen2;

	lLen2 = strlen(GetResString(IDS_IRC)) + 1;
	memcpy(cButtonStrings+lLen, GetResString(IDS_IRC), lLen2);
	lLen += lLen2;

	lLen2 = strlen(GetResString(IDS_EM_STATISTIC)) + 1;
	memcpy(cButtonStrings+lLen, GetResString(IDS_EM_STATISTIC), lLen2);
	lLen += lLen2;

	lLen2 = strlen(GetResString(IDS_EM_PREFS)) + 1;
	memcpy(cButtonStrings+lLen, GetResString(IDS_EM_PREFS), lLen2);
	lLen += lLen2;

	memcpy(cButtonStrings+lLen, "\0", 1);

	AddStrings(cButtonStrings);

	// add buttons:	
	for(int i = 0; i < 9; i++)
	{		
		TBButtons[i].fsState	= TBSTATE_ENABLED;
		TBButtons[i].fsStyle	= TBSTYLE_CHECK;//TBSTYLE_CHECKGROUP;
		TBButtons[i].iBitmap	= i;
		TBButtons[i].idCommand	= IDC_TOOLBARBUTTON + i;
		TBButtons[i].iString	= i;

		switch(i)
		{		
		case 0:
		case 8:
			TBButtons[i].fsStyle = TBSTYLE_BUTTON;
			break;
		case 1:
			TBButtons[i].fsState |= TBSTATE_CHECKED;
		}
	}
	m_iLastPressedButton = IDC_TOOLBARBUTTON+1;
	
	TBBUTTON sepButton;
	sepButton.idCommand = 0;
	sepButton.fsStyle = TBSTYLE_SEP;
	sepButton.fsState = TBSTATE_ENABLED;
	sepButton.iString = -1;
	sepButton.iBitmap = -1;
	
	CString config = theApp.glob_prefs->GetToolbarSettings();
	for(i=0;i<config.GetLength();i+=2)
	{
		int index = atoi(config.Mid(i,2));
		if(index==99)
		{
			AddButtons(1,&sepButton);
			continue;
		}
		AddButtons(1,&TBButtons[index]);
	}

	// recalc toolbar-size:	
	Localize();		// at first we have to localize the button-text!!!
	m_iToolbarLabelSettings=4;
	ChangeTextLabelStyle(theApp.glob_prefs->GetToolbarLabelSettings(), false);
	SetBtnWidth();		// then calc and set the button width
	AutoSize();		// and finally call the original (but maybe obsolete) function
	
	// add speed-meter to upper-right corner
	CRect rClient;
	GetClientRect(&rClient);
	rClient.DeflateRect(7,7);
	int iHeight = rClient.Height();
	rClient.left = rClient.right - iHeight * 2;
	if(m_bUseSpeedMeter)
		m_ctrlSpeedMeter.CreateEx(WS_EX_STATICEDGE, NULL, NULL, WS_CHILD | WS_VISIBLE, rClient, this, 123);
	else
		m_ctrlSpeedMeter.CreateEx(WS_EX_STATICEDGE, NULL, NULL, WS_CHILD, rClient, this, 123);
	m_ctrlSpeedMeter.SetRange(0,100);

	// resize speed-meter	
	CRect r;
	GetWindowRect(&r);
	OnSize(0,r.Width(),r.Height());
}

void CMuleToolbarCtrl::Localize(void)
{	
	if(m_hWnd)
	{
		static const int TBStringIDs[]={IDS_MAIN_BTN_CONNECT,IDS_EM_SERVER,IDS_EM_TRANS,IDS_EM_SEARCH,IDS_EM_FILES,IDS_EM_MESSAGES,IDS_IRC,IDS_EM_STATISTIC,IDS_EM_PREFS};
		TBBUTTONINFO tbi;
		tbi.dwMask = TBIF_TEXT;
		tbi.cbSize = sizeof (TBBUTTONINFO);
		CString buffer;

		for (int i = 0; i < sizeof (TBStringIDs) / sizeof(TBStringIDs[0]); i++)
		{
			// buffer.LoadString(TBStringIDs[i]);
			buffer = GetResString(TBStringIDs[i]); // EC
			buffer.Remove('&');
			sprintf(TBStrings[i], "%s", buffer);
			tbi.pszText = TBStrings[i];
			SetButtonInfo(IDC_TOOLBARBUTTON+i, &tbi);
		}

		AutoSize();
		SetBtnWidth();
	}
}

void CMuleToolbarCtrl::OnSize(UINT nType, int cx, int cy)
{
	CToolBarCtrl::OnSize(nType, cx, cy);
		
	if(m_ctrlSpeedMeter.m_hWnd && m_bUseSpeedMeter)
	{
		CRect rClient;
		GetClientRect(&rClient);
		rClient.DeflateRect(7,7);

		int iHeight = rClient.Height();
		int iLeft  = rClient.right - iHeight;
		
		CSize csMaxSize;
		GetMaxSize(&csMaxSize);
		if(rClient.left + csMaxSize.cx + 7 > iLeft)
		{	
			m_ctrlSpeedMeter.ShowWindow(SW_HIDE);
			return;
		}
		
		iLeft -= iHeight;
		if(iLeft <= rClient.left + csMaxSize.cx + 7)
			iLeft = rClient.left + csMaxSize.cx + 7;
		rClient.left = iLeft;
		
		m_ctrlSpeedMeter.SetWindowPos(NULL, rClient.left, rClient.top, 
										rClient.Width(), rClient.Height(), 
											SWP_NOZORDER | SWP_SHOWWINDOW);
	}

	SetBtnWidth();
	AutoSize();
}


void CMuleToolbarCtrl::ShowSpeedMeter(bool bShow)
{
	m_bUseSpeedMeter = bShow;
	
	if(bShow)
	{
		if(!m_ctrlSpeedMeter.IsWindowVisible())
		{
			m_ctrlSpeedMeter.EnableWindow(true);
			//m_ctrlSpeedMeter.ShowWindow(SW_SHOW);
		// resize speed-meter	
			CRect r;
			GetWindowRect(&r);
			OnSize(0,r.Width(),r.Height());
		}
	}
	else
	{
		m_ctrlSpeedMeter.EnableWindow(false);
		m_ctrlSpeedMeter.ShowWindow(SW_HIDE);
		CRect rInvalidate;
		m_ctrlSpeedMeter.GetWindowRect(&rInvalidate);
		ScreenToClient(rInvalidate);
		InvalidateRect(rInvalidate);
	}
}

void CMuleToolbarCtrl::SetBtnWidth()
{
	if(m_iToolbarLabelSettings==1)
	{
		CString strMaxText = "";
		char szBuf[200] = "";
		
		TBBUTTONINFO tbi;
		LPTBBUTTONINFO lptbbi;
		lptbbi = &tbi;
		tbi.dwMask = TBIF_TEXT;
		tbi.cbSize = sizeof (TBBUTTONINFO);
		tbi.pszText = szBuf;
		tbi.cchText = 200;
		
		CDC *pDC = GetDC();
		CFont *pFnt = GetFont();
		CFont *pOldFnt = pDC->SelectObject(pFnt);
		CRect r(0,0,0,0);

	/*	for(int i = 0; i < GetButtonCount(); i++)
		{		
			// get button text
			GetButtonInfo(IDC_TOOLBARBUTTON+i, lptbbi);
			// calculate textsize
			pDC->DrawText(szBuf, strlen(szBuf), r, DT_SINGLELINE | DT_CALCRECT);
		}

		pDC->SelectObject(pOldFnt);
		ReleaseDC(pDC); // FoRcHa

		// calculate the max. possible button-size
		int iCalcSize = r.Width() + 10;
	*/
		// pooz
		// calculate the max. possible button-size
		int iCalcSize = 0;

		for(int i = 0; i < GetButtonCount(); i++)
		{  
			// get button text
			GetButtonInfo(IDC_TOOLBARBUTTON+i, lptbbi);
			// calculate textsize
			pDC->DrawText(szBuf, strlen(szBuf), r, DT_SINGLELINE | DT_CALCRECT);

			if (r.Width() > iCalcSize)
				iCalcSize = r.Width();
		}

		iCalcSize += 10;

		pDC->SelectObject(pOldFnt);
		ReleaseDC(pDC); // FoRcHa
		// end pooz
		GetClientRect(&r);
		int iMaxPossible = r.Width() / 9;

		// if the buttons are to big, reduze their size
		if(iCalcSize > iMaxPossible)
			iCalcSize = iMaxPossible;

		SetButtonWidth(iCalcSize, iCalcSize);
	}
	else
	{
		SetButtonSize(CSize(0,0));
		SetButtonWidth(0,0);
	}
}

void CMuleToolbarCtrl::OnNMRclick(NMHDR *pNMHDR, LRESULT *pResult)
{
	EMULE_TRY
	POINT point;
	GetCursorPos (&point);
	
	CMenu m_ToolbarMenu;
	m_ToolbarMenu.CreatePopupMenu();
	CMenu m_BitmapsMenu;
	m_BitmapsMenu.CreateMenu();
	m_BitmapsMenu.AppendMenu(MF_STRING,MP_SELECTTOOLBARBITMAP, GetResString(IDS_SELECTTOOLBARBITMAP));
	m_BitmapsMenu.AppendMenu(MF_STRING,MP_SELECTTOOLBARBITMAPDIR, GetResString(IDS_SELECTTOOLBARBITMAPDIR));
	m_BitmapsMenu.AppendMenu(MF_SEPARATOR);
	m_BitmapsMenu.AppendMenu(MF_STRING,MP_TOOLBARBITMAP,GetResString(IDS_DEFAULT));
	bitmappaths.RemoveAll();
	CString currentBitmapSettings = theApp.glob_prefs->GetToolbarBitmapSettings();
	bool checked=false;
	if(currentBitmapSettings=="")
	{
		m_BitmapsMenu.CheckMenuItem(MP_TOOLBARBITMAP,MF_CHECKED);
		m_BitmapsMenu.EnableMenuItem(MP_TOOLBARBITMAP,MF_DISABLED);
		checked=true;
	}
	bitmappaths.Add("");
	int i=1;
	if(theApp.glob_prefs->GetToolbarBitmapFolderSettings() != "")
	{
		WIN32_FIND_DATA FileData;
		HANDLE hSearch;
		bool fFinished = false;
		CString configDir;
		configDir = theApp.glob_prefs->GetToolbarBitmapFolderSettings();
		hSearch = FindFirstFile(configDir + CString("\\*.eMuleToolbar.bmp"), &FileData);
		if (hSearch == INVALID_HANDLE_VALUE)
			fFinished = true;
		for(;!fFinished && i<50;i++)
		{
			CString bitmapFileName = FileData.cFileName;
			m_BitmapsMenu.AppendMenu(MF_STRING,MP_TOOLBARBITMAP+i,bitmapFileName.Left(bitmapFileName.GetLength()-17));
			bitmappaths.Add(configDir + CString("\\")+bitmapFileName);
			if(!checked && currentBitmapSettings==bitmappaths[i])
			{
				m_BitmapsMenu.CheckMenuItem(MP_TOOLBARBITMAP+i,MF_CHECKED);
				m_BitmapsMenu.EnableMenuItem(MP_TOOLBARBITMAP+i,MF_DISABLED);
				checked=true;
			}
			if (!FindNextFile(hSearch, &FileData))
				fFinished = true;
		}
		FindClose(hSearch);
	}
	if(!checked)
	{
		m_BitmapsMenu.AppendMenu(MF_STRING,MP_TOOLBARBITMAP+i,currentBitmapSettings);
		m_BitmapsMenu.CheckMenuItem(MP_TOOLBARBITMAP+i,MF_CHECKED);
		m_BitmapsMenu.EnableMenuItem(MP_TOOLBARBITMAP+i,MF_DISABLED);
		bitmappaths.Add(currentBitmapSettings);
	}
	m_ToolbarMenu.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)m_BitmapsMenu.m_hMenu, GetResString(IDS_TOOLBARSKINS));
	CMenu m_TextLabelsMenu;
	m_TextLabelsMenu.CreateMenu();
	m_TextLabelsMenu.AppendMenu(MF_STRING,MP_NOTEXTLABELS, GetResString(IDS_NOTEXTLABELS));
	m_TextLabelsMenu.AppendMenu(MF_STRING,MP_TEXTLABELS,GetResString(IDS_ENABLETEXTLABELS));
	m_TextLabelsMenu.AppendMenu(MF_STRING,MP_TEXTLABELSONRIGHT,GetResString(IDS_TEXTLABELSONRIGHT));
	m_TextLabelsMenu.CheckMenuItem(theApp.glob_prefs->GetToolbarLabelSettings(),MF_BYPOSITION|MF_CHECKED);
	m_TextLabelsMenu.EnableMenuItem(theApp.glob_prefs->GetToolbarLabelSettings(),MF_BYPOSITION|MF_DISABLED);
	m_ToolbarMenu.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)m_TextLabelsMenu.m_hMenu, GetResString(IDS_TEXTLABELS));
	m_ToolbarMenu.AppendMenu(MF_STRING,MP_CUSTOMIZETOOLBAR, GetResString(IDS_CUSTOMIZETOOLBAR));
	m_ToolbarMenu.TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, this);

	*pResult = TRUE;

	EMULE_CATCH
}

void CMuleToolbarCtrl::OnTbnQueryDelete(NMHDR *pNMHDR, LRESULT *pResult)
{
	*pResult = TRUE;
}

void CMuleToolbarCtrl::OnTbnQueryInsert(NMHDR *pNMHDR, LRESULT *pResult)
{
	*pResult = TRUE;
}

void CMuleToolbarCtrl::OnTbnGetButtonInfo(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTOOLBAR pNMTB = reinterpret_cast<LPNMTOOLBAR>(pNMHDR);
	if (pNMTB->iItem > 8)
	{
		*pResult = FALSE;
	}
	else
	{
		pNMTB->pszText=TBStrings[pNMTB->iItem];
		pNMTB->tbButton = TBButtons[pNMTB->iItem];
		*pResult = TRUE;
	}
}

void CMuleToolbarCtrl::OnTbnToolbarChange(NMHDR *pNMHDR, LRESULT *pResult)
{
	TBBUTTON buttoninfo;
	char config[256]="";
	for(int i=0;i<GetButtonCount();i++)
	{
		if(GetButton(i, &buttoninfo))
			switch(buttoninfo.idCommand)
			{
			case 0:
				sprintf(config, "%s99", config);
				break;
			default:
				sprintf(config, "%s%.2lu", config, buttoninfo.idCommand-IDC_TOOLBARBUTTON);
				break;
			}
	}
	theApp.glob_prefs->SetToolbarSettings(config);
	*pResult = 0;
}

void CMuleToolbarCtrl::ChangeToolbarBitmap(CString path, bool refresh)
{
	CImageList ImageList;
	CEnBitmap Bitmap;
	if(path!="" && Bitmap.LoadImage(path));
	else
		Bitmap.LoadBitmap(IDB_TOOLBAR);
	BITMAP bm;
	Bitmap.GetObject(sizeof(BITMAP),&bm);
	ImageList.Create(bm.bmWidth/11, bm.bmHeight, ILC_COLOR32 | ILC_MASK, 11, 1);
	ImageList.Add(&Bitmap, RGB(255,0,255));
	SetImageList(&ImageList);
	ImageList.Detach();
	Bitmap.DeleteObject();
	if(refresh)
		Refresh();
}

BOOL CMuleToolbarCtrl::OnCommand(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	switch (wParam)
	{
		case MP_SELECTTOOLBARBITMAPDIR:
			theApp.glob_prefs->SetToolbarBitmapFolderSettings(BrowseFolder(m_hWnd,GetResString(IDS_SELECT_TOOLBARBITMAPDIR),theApp.glob_prefs->GetToolbarBitmapFolderSettings()));
			break;
		
		case MP_CUSTOMIZETOOLBAR:
			Customize();
			break;

		case MP_SELECTTOOLBARBITMAP:
		{
			CFileDialog dialog(TRUE, "eMuleToolbar.bmp", NULL, NULL, "*.eMuleToolbar.bmp|*.eMuleToolbar.bmp||");
			if (IDOK == dialog.DoModal())
				if(theApp.glob_prefs->GetToolbarBitmapSettings()!=dialog.GetPathName())
				{
					ChangeToolbarBitmap(dialog.GetPathName(), true);
					theApp.glob_prefs->SetToolbarBitmapSettings(dialog.GetPathName());
				}
			break;
		}

		case MP_NOTEXTLABELS:
			ChangeTextLabelStyle(0,TRUE);
			theApp.glob_prefs->SetToolbarLabelSettings(0);
			break;

		case MP_TEXTLABELS:
			ChangeTextLabelStyle(1,TRUE);
			theApp.glob_prefs->SetToolbarLabelSettings(1);
			break;

		case MP_TEXTLABELSONRIGHT:
			ChangeTextLabelStyle(2,TRUE);
			theApp.glob_prefs->SetToolbarLabelSettings(2);
			break;
		default:
			if(wParam >= MP_TOOLBARBITMAP && wParam <= MP_TOOLBARBITMAP+50)
				if(theApp.glob_prefs->GetToolbarBitmapSettings()!=bitmappaths[wParam-MP_TOOLBARBITMAP])
				{
					ChangeToolbarBitmap(bitmappaths[wParam-MP_TOOLBARBITMAP], true);
					theApp.glob_prefs->SetToolbarBitmapSettings(bitmappaths[wParam-MP_TOOLBARBITMAP]);
				}
	}

	return true;

	EMULE_CATCH

	return false;
}

void CMuleToolbarCtrl::ChangeTextLabelStyle(int settings, bool refresh)
{
	if(m_iToolbarLabelSettings!=settings)
	{
		switch(settings)
		{
			case 0:
				SetStyle(GetStyle() & ~TBSTYLE_LIST);
				SetMaxTextRows(0);
				break;
			case 1:
				SetStyle(GetStyle() & ~TBSTYLE_LIST);
				SetMaxTextRows(1);
				break;
			case 2:
				SetStyle(GetStyle() | TBSTYLE_LIST);
				SetMaxTextRows(1);
				break;
		}
		if((m_iToolbarLabelSettings+settings)!=2) //if not changing between no labels and labels on right 
		{
			for(int i = 0; i < 9; i++)
			{	
				TBBUTTONINFO buttonInfo;
				buttonInfo.cbSize=sizeof(buttonInfo);
				buttonInfo.dwMask=TBIF_STYLE;
				GetButtonInfo(IDC_TOOLBARBUTTON + i, &buttonInfo);
				if(settings==1)
					buttonInfo.fsStyle &= ~TBSTYLE_AUTOSIZE;
				else
					buttonInfo.fsStyle |= TBSTYLE_AUTOSIZE;
				SetButtonInfo(IDC_TOOLBARBUTTON + i, &buttonInfo);
			}
		}
		m_iToolbarLabelSettings=settings;
		if(refresh)
			Refresh();
	}
}

void CMuleToolbarCtrl::Refresh()
{
	SetBtnWidth();
	AutoSize();
	CRect rToolbarRect;
	GetWindowRect(&rToolbarRect);
	static int previousheight=0;
	if(previousheight==rToolbarRect.Height())
	{
		Invalidate();
		RedrawWindow();
	}
	else
	{
		previousheight=rToolbarRect.Height();
		CRect rClientRect;
		theApp.emuledlg->GetClientRect(&rClientRect);
		CRect rStatusbarRect;
		theApp.emuledlg->statusbar.GetWindowRect(&rStatusbarRect);
		rClientRect.top += rToolbarRect.Height();
		rClientRect.bottom -= rStatusbarRect.Height();

		CWnd* wnds[]={&theApp.emuledlg->serverwnd,&theApp.emuledlg->transferwnd,&theApp.emuledlg->sharedfileswnd,&theApp.emuledlg->searchwnd,&theApp.emuledlg->chatwnd,&theApp.emuledlg->ircwnd,&theApp.emuledlg->statisticswnd};
		for(int i=0;i<7;i++)
		{
			wnds[i]->SetWindowPos(NULL, rClientRect.left, rClientRect.top,rClientRect.Width(), rClientRect.Height(), SWP_NOZORDER);
			theApp.emuledlg->RemoveAnchor(wnds[i]->m_hWnd);
			theApp.emuledlg->AddAnchor(wnds[i]->m_hWnd,TOP_LEFT,BOTTOM_RIGHT);
		}
		theApp.emuledlg->Invalidate();
		theApp.emuledlg->RedrawWindow();
	}
}