// PPgConnection.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgConnection.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPPgConnection dialog

IMPLEMENT_DYNAMIC(CPPgConnection, CPropertyPage)
CPPgConnection::CPPgConnection()
	: CPropertyPage(CPPgConnection::IDD)
{
}

CPPgConnection::~CPPgConnection()
{
}

void CPPgConnection::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CONTYPE, m_conprof);
}

BEGIN_MESSAGE_MAP(CPPgConnection, CPropertyPage)
	ON_CBN_SELCHANGE(IDC_CONTYPE, OnCbnSelchangeConType)
	ON_BN_CLICKED(IDC_UDPDISABLE, OnEnChangeUDPDisable)
	ON_EN_CHANGE(IDC_UDPPORT, OnSettingsChange)	//Cax2 bugfix
	ON_EN_KILLFOCUS(IDC_DOWNLOAD_CAP, OnSpeedChange)
	ON_EN_KILLFOCUS(IDC_UPLOAD_CAP, OnSpeedChange)
	ON_EN_KILLFOCUS(IDC_MAXDOWN, OnSpeedChange)
	ON_EN_KILLFOCUS(IDC_MAXUP, OnSpeedChange)
	ON_EN_CHANGE(IDC_DOWNLOAD_CAP, OnSettingsChange)
	ON_EN_CHANGE(IDC_UPLOAD_CAP, OnSettingsChange)
	ON_EN_CHANGE(IDC_MAXDOWN, OnSettingsChange)
	ON_EN_CHANGE(IDC_MAXUP, OnSettingsChange)
	ON_EN_CHANGE(IDC_PORT, OnSettingsChange)
	ON_EN_CHANGE(IDC_MAXCON, OnSettingsChange)
	ON_BN_CLICKED(IDC_DISABLE_XS, OnBnClickedDisableXS)	//Tarod
	ON_BN_CLICKED(IDC_LANCASTENABLE, OnSettingsChange)	// Moosetea
	ON_EN_CHANGE(IDC_MAXCON5, OnSettingsChange) // DonGato
    ON_BN_CLICKED(IDC_ENABLE_XSUPTO, OnBnClickedDisableXSUpTo) // DonGato
	ON_EN_CHANGE(IDC_XSUPTO, OnSettingsChange) // DonGato
	ON_BN_CLICKED(IDC_LIMITQR, OnSettingsChange) // DonGato
	ON_EN_CHANGE(IDC_QUEUESIZE, OnSettingsChange)	// SeeWen + Cax2
	ON_EN_KILLFOCUS(IDC_QUEUESIZE, OnQueueChange)
	ON_BN_CLICKED(IDC_SHOWOVERHEAD, OnSettingsChange)
END_MESSAGE_MAP()

BOOL CPPgConnection::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	m_conprof.SetItemData(m_conprof.AddString("Custom"),0);
	m_conprof.SetItemData(m_conprof.AddString("ADSL 256/128"),1);
	m_conprof.SetItemData(m_conprof.AddString("ADSL 512/128"),2);
	m_conprof.SetItemData(m_conprof.AddString("ADSL 512/256"),3);
	m_conprof.SetItemData(m_conprof.AddString("ADSL 768/128"),4);
	m_conprof.SetItemData(m_conprof.AddString("ADSL 1024/256"),5);
	m_conprof.SetItemData(m_conprof.AddString("ADSL 1024/512"),6);
	m_conprof.SetItemData(m_conprof.AddString("Cable"),7);
	m_conprof.SetItemData(m_conprof.AddString("T1"),8);
	m_conprof.SetItemData(m_conprof.AddString("Modem 56k"),9);
	m_conprof.SetItemData(m_conprof.AddString("ISDN 64k"),10);
	m_conprof.SetItemData(m_conprof.AddString("ISDN 128k"),11);
		
	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgConnection::LoadSettings(void)
{
	if(m_hWnd)
	{
		if( app_prefs->GetMaxUpload() != 0 ){
			if( app_prefs->GetMaxUpload() < 4 && (app_prefs->GetMaxUpload()*3 < app_prefs->GetMaxDownloadValue()))
				app_prefs->SetMaxDownload( app_prefs->GetMaxUpload()*3);
	
			if( app_prefs->GetMaxUpload() < 10 && (app_prefs->GetMaxUpload()*4 < app_prefs->GetMaxDownloadValue()))
				app_prefs->SetMaxDownload(app_prefs->GetMaxUpload()*4);
		}
		CString strBuffer;
	
		strBuffer.Format("%d", app_prefs->GetPort());	
		GetDlgItem(IDC_PORT)->SetWindowText(strBuffer);

		strBuffer.Format("%d", (app_prefs->GetUDPPort()>0)?app_prefs->GetUDPPort():app_prefs->GetPort()+10); //Cax2
		GetDlgItem(IDC_UDPPORT)->SetWindowText(strBuffer);
		CheckDlgButton(IDC_UDPDISABLE,(app_prefs->GetUDPPort()==0));
		GetDlgItem(IDC_UDPPORT)->EnableWindow(app_prefs->GetUDPPort()>0);

		// DonGato
		for(int i = 0; i != m_conprof.GetCount(); i++) {
		if(m_conprof.GetItemData(i) == app_prefs->Profile())
			m_conprof.SetCurSel(i);
		}
		//m_conprof.SetItemData (m_conprof app_prefs->prefs->Profile)
		if(app_prefs->Profile() == 0) {
			EnableEditBoxes();
		} else {
			DisableEditBoxes();
		}
		
		strBuffer.Format("%d", app_prefs->GetMaxGraphDownloadRate());
		GetDlgItem(IDC_DOWNLOAD_CAP)->SetWindowText(strBuffer);
		
		strBuffer.Format("%d", app_prefs->GetMaxGraphUploadRate());
		GetDlgItem(IDC_UPLOAD_CAP)->SetWindowText(strBuffer);

		if(app_prefs->GetMaxDownloadValue() == 0xFFFF)
			GetDlgItem(IDC_MAXDOWN)->SetWindowText("0");
		else
		{
			strBuffer.Format("%d", app_prefs->GetMaxDownloadValue());
			GetDlgItem(IDC_MAXDOWN)->SetWindowText(strBuffer);
		}
		if(app_prefs->GetMaxUpload() == 0xFFFF)
			GetDlgItem(IDC_MAXUP)->SetWindowText("0");
		else
		{
			strBuffer.Format("%d", app_prefs->GetMaxUpload());
			GetDlgItem(IDC_MAXUP)->SetWindowText(strBuffer);
		}

		strBuffer.Format("%d", app_prefs->GetMaxConnections());
		GetDlgItem(IDC_MAXCON)->SetWindowText(strBuffer);

		// Tarod
		if (app_prefs->IsDisabledXS())
			CheckDlgButton(IDC_DISABLE_XS,1);
		else
			CheckDlgButton(IDC_DISABLE_XS,0);

		// Moosetea
		if (app_prefs->GetLancastEnabled())
			CheckDlgButton(IDC_LANCASTENABLE,1);
		else
			CheckDlgButton(IDC_LANCASTENABLE,0);

		strBuffer.Format("%d", app_prefs->GetQueueSize());
		GetDlgItem(IDC_QUEUESIZE)->SetWindowText(strBuffer);

		// DonGato
		strBuffer.Format("%d", app_prefs->GetMaxConperFive());
		GetDlgItem(IDC_MAXCON5)->SetWindowText(strBuffer);

		if (app_prefs->UseRemoteQueueLimit())
			CheckDlgButton(IDC_LIMITQR,1);
		else
			CheckDlgButton(IDC_LIMITQR,0);

		m_RQLimit=app_prefs->GetRemoteQueueLimit();

		if (app_prefs->ShowOverhead())
			CheckDlgButton(IDC_SHOWOVERHEAD,1);
		else
			CheckDlgButton(IDC_SHOWOVERHEAD,0);

		if (app_prefs->DisableXSUpTo())
			CheckDlgButton(IDC_ENABLE_XSUPTO,1);
		else
			CheckDlgButton(IDC_ENABLE_XSUPTO,0);
		OnBnClickedDisableXS();

		strBuffer.Format("%d", app_prefs->XSUpTo());
		GetDlgItem(IDC_XSUPTO)->SetWindowText(strBuffer);

		SetModified(FALSE);	// FoRcHa
	}
}

BOOL CPPgConnection::OnApply()
{
//	CSingleLock PrefLock(&(app_prefs->m_Pref_Mutex),TRUE); 

	if(m_bModified)
	{
		OnSpeedChange();
		char buffer[510];
		int lastmaxgu = app_prefs->GetMaxGraphUploadRate();
		int lastmaxgd = app_prefs->GetMaxGraphDownloadRate();
	
		OnCbnSelchangeConType();
		app_prefs->SetProfile(m_conprof.GetCurSel());
			
		if(GetDlgItem(IDC_DOWNLOAD_CAP)->GetWindowTextLength())
		{ 
			GetDlgItem(IDC_DOWNLOAD_CAP)->GetWindowText(buffer,20);
			app_prefs->SetMaxGraphDownloadRate( (atoi(buffer)) ? atoi(buffer) : 100);
		}
		if(GetDlgItem(IDC_UPLOAD_CAP)->GetWindowTextLength())
		{
			GetDlgItem(IDC_UPLOAD_CAP)->GetWindowText(buffer,20);
			app_prefs->SetMaxGraphUploadRate( (atoi(buffer)) ? atoi(buffer) : 25);
		}
	
		if(GetDlgItem(IDC_MAXUP)->GetWindowTextLength())
		{
			GetDlgItem(IDC_MAXUP)->GetWindowText(buffer,20);
			app_prefs->SetMaxUpload((atoi(buffer)) ? atoi(buffer) : 0xFFFF);
		}
		if(GetDlgItem(IDC_MAXDOWN)->GetWindowTextLength())
		{
			GetDlgItem(IDC_MAXDOWN)->GetWindowText(buffer,20);
			app_prefs->SetMaxDownload((atoi(buffer)) ? atoi(buffer) : 0xFFFF);
		}
		
		if(GetDlgItem(IDC_PORT)->GetWindowTextLength())
		{
			GetDlgItem(IDC_PORT)->GetWindowText(buffer,20);
			app_prefs->SetPort( (atoi(buffer)) ? atoi(buffer) : 4662);
		}
		
		if(GetDlgItem(IDC_MAXCON)->GetWindowTextLength())
		{
			GetDlgItem(IDC_MAXCON)->GetWindowText(buffer,20);
			app_prefs->SetMaxConnections((atoi(buffer)) ? atoi(buffer) : 500);
		}
		
		if(GetDlgItem(IDC_UDPPORT)->GetWindowTextLength())
		{
			GetDlgItem(IDC_UDPPORT)->GetWindowText(buffer,20);
			app_prefs->SetUDPPort( (atoi(buffer) && !IsDlgButtonChecked(IDC_UDPDISABLE) ) ? atoi(buffer) : 0);
		}
		//if(IsDlgButtonChecked(IDC_UDPDISABLE)) app_prefs->prefs->udpport=0;
		GetDlgItem(IDC_UDPPORT)->EnableWindow(!IsDlgButtonChecked(IDC_UDPDISABLE));
		app_prefs->SetShowOverhead( IsDlgButtonChecked(IDC_SHOWOVERHEAD));	//Cax2
		theApp.emuledlg->ResizeStatusBar();	//Cax2
		theApp.emuledlg->ShowTransferRate(true);
		if(lastmaxgu != app_prefs->GetMaxGraphUploadRate()) 
			theApp.emuledlg->statisticswnd.SetARange(false,app_prefs->GetMaxGraphUploadRate());
		if(lastmaxgd!=app_prefs->GetMaxGraphDownloadRate())
			theApp.emuledlg->statisticswnd.SetARange(true,app_prefs->GetMaxGraphDownloadRate());
		
		// Moosetea
		app_prefs->SetLancastEnabled(IsDlgButtonChecked(IDC_LANCASTENABLE));

		//// Start: setrange of the toolbar-speed-meter [FoRcHa] //////
		int iMaxRange = app_prefs->GetMaxGraphDownloadRate();
		if(app_prefs->GetMaxGraphUploadRate() > iMaxRange)
			iMaxRange = app_prefs->GetMaxGraphUploadRate();
		UINT nLastMaxRange, nLastMinRange;
		theApp.emuledlg->toolbar.GetSpeedMeterRange(nLastMaxRange, nLastMinRange);
		if((int)nLastMaxRange != iMaxRange)
			theApp.emuledlg->toolbar.SetSpeedMeterRange(iMaxRange, nLastMinRange);
		//// End: setrange of the toolbar-speed-meter [FoRcHa] ////////
	
		if(app_prefs->GetMaxConnections() > (unsigned)::GetMaxConnections())
		{
			CString strMessage;
			strMessage.Format(GetResString(IDS_PW_WARNING), GetResString(IDS_PW_MAXC), ::GetMaxConnections());
			int iResult = MessageBox(strMessage, GetResString(IDS_PW_MAXC), MB_ICONWARNING | MB_YESNO);
			if(iResult != IDYES)
			{
				//TODO: set focus to max connection?
				return FALSE;
			}
		}
	
		if(GetDlgItem(IDC_MAXCON)->GetWindowTextLength())
		{
			GetDlgItem(IDC_MAXCON)->GetWindowText(buffer,20);
			app_prefs->SetMaxConnections( (atoi(buffer)) ?
				atoi(buffer) : CPreferences::GetRecommendedMaxConnections());
		}
		
		// SeeWen QUEUESIZE
		GetDlgItem(IDC_QUEUESIZE)->GetWindowText(buffer, 20) ;
		app_prefs->SetQueueSize( atoi(buffer) );

		// DonGato
		GetDlgItem(IDC_MAXCON5)->GetWindowText(buffer, 20);
		app_prefs->SetMaxDownloadConperFive( atoi(buffer));
		int nMax = (LOBYTE(theApp.glob_prefs->GetWindowsVersion()) == 0x04)?100:200;

		if (app_prefs->GetMaxConperFive() > nMax)
		{
			app_prefs->SetMaxDownloadConperFive(nMax);
			sprintf(buffer, "%d",app_prefs->GetMaxConperFive());
			GetDlgItem(IDC_MAXCON5)->SetWindowText(buffer);
		} 
		else if (app_prefs->GetMaxConperFive() < 5)
		{
			sprintf(buffer, "%d",app_prefs->GetMaxConperFive());
			GetDlgItem(IDC_MAXCON5)->SetWindowText(buffer);
			app_prefs->SetMaxDownloadConperFive(5);
		}

		app_prefs->SetRemoteQueueLimit(m_RQLimit);
		app_prefs->UseRemoteQueueLimit((int8)IsDlgButtonChecked(IDC_LIMITQR));
		
		// Tarod
		app_prefs->SetDisabledXS( (int8)IsDlgButtonChecked(IDC_DISABLE_XS) );
	
		// DonGato
		app_prefs->UseRemoteQueueLimit((int8)IsDlgButtonChecked(IDC_LIMITQR));
		app_prefs->SetDisableXSUpTo( (int8)IsDlgButtonChecked(IDC_ENABLE_XSUPTO) );
		GetDlgItem(IDC_XSUPTO)->GetWindowText(buffer, 20);
		app_prefs->SetXSUpTo( atoi(buffer));
		if (app_prefs->XSUpTo() > app_prefs->GetMaxSourcePerFileSoft())
		{
			app_prefs->SetXSUpTo( app_prefs->GetMaxSourcePerFileSoft());
			sprintf(buffer, "%d",app_prefs->XSUpTo());
			GetDlgItem(IDC_XSUPTO)->SetWindowText(buffer);
		} 

		SetModified(FALSE);
	}

	return CPropertyPage::OnApply();
}

void CPPgConnection::Localize(void)
{	
	if(m_hWnd)
	{
		SetWindowText(GetResString(IDS_PW_CONNECTION));
		GetDlgItem(IDC_CONPROF)->SetWindowText(GetResString(IDS_CONPROF)); // DonGato
		GetDlgItem(IDC_TR_FRM)->SetWindowText(GetResString(IDS_TR_FRM));
		GetDlgItem(IDC_CAPACITIES)->SetWindowText(GetResString(IDS_PW_CON_CAP));
		GetDlgItem(IDC_LIMITS)->SetWindowText(GetResString(IDS_PW_CON_LIMIT));
		GetDlgItem(IDC_DCAP_LBL)->SetWindowText(GetResString(IDS_PW_CON_DOWNLBL));
		GetDlgItem(IDC_UCAP_LBL)->SetWindowText(GetResString(IDS_PW_CON_UPLBL));
		GetDlgItem(IDC_KBS1)->SetWindowText(GetResString(IDS_KBYTESEC));
		GetDlgItem(IDC_KBS2)->SetWindowText(GetResString(IDS_KBYTESEC));
		GetDlgItem(IDC_QUEUE_FRM)->SetWindowText(GetResString(IDS_QUEUE_FRM));
		GetDlgItem(IDC_QUEUESIZE_TEXT)->SetWindowText(GetResString(IDS_QUEUESIZE_TEXT));
		GetDlgItem(IDC_MAXCONN_FRM)->SetWindowText(GetResString(IDS_PW_MAXC));
		GetDlgItem(IDC_CLIENTPORT_FRM)->SetWindowText(GetResString(IDS_PW_CLIENTPORT));
		GetDlgItem(IDC_DISABLE_XS)->SetWindowText(GetResString(IDS_DISABLE_XS)); // Tarod
		CString buffer;		 // Cax2 - remote queue handling
		buffer.Format(IDS_REMOTEQUEUELIMIT,m_RQLimit);
		GetDlgItem(IDC_LIMITQR)->SetWindowText(buffer);
		GetDlgItem(IDC_MAXCON5_TEXT)->SetWindowText(GetResString(IDS_MAXCON5_TEXT)); // DonGato
		GetDlgItem(IDC_UDPPORTLABEL)->SetWindowText(GetResString(IDS_UDPPORT));
		GetDlgItem(IDC_UDPDISABLE)->SetWindowText(GetResString(IDS_UDPDISABLED));
		GetDlgItem(IDC_ENABLE_XSUPTO)->SetWindowText(GetResString(IDS_ENABLE_XSUPTO));
		GetDlgItem(IDC_XSSOURCES)->SetWindowText(GetResString(IDS_SOURCES_PF_FILES));
		GetDlgItem(IDC_SHOWOVERHEAD)->SetWindowText(GetResString(IDS_SHOWOVERHEAD)); // EC
		GetDlgItem(IDC_LANCASTENABLE)->SetWindowText(GetResString(IDS_LANCASTENABLE)); // EC

	}
}

void CPPgConnection::OnCbnSelchangeConType(void)
{
	if (m_conprof.GetCurSel() != CB_ERR){
		WORD conprofsel =  m_conprof.GetItemData(m_conprof.GetCurSel());
		if (conprofsel == 0){
			EnableEditBoxes();
		}
		else if (conprofsel == 1){
			DisableEditBoxes();
			GetDlgItem(IDC_DOWNLOAD_CAP)->SetWindowText("32");
			GetDlgItem(IDC_UPLOAD_CAP)->SetWindowText("16");
			GetDlgItem(IDC_MAXDOWN)->SetWindowText("32");
			GetDlgItem(IDC_MAXUP)->SetWindowText("14");
			GetDlgItem(IDC_MAXCON)->SetWindowText("160");
		}
		else if (conprofsel == 2){
			DisableEditBoxes();
			GetDlgItem(IDC_DOWNLOAD_CAP)->SetWindowText("64");
			GetDlgItem(IDC_UPLOAD_CAP)->SetWindowText("16");
			GetDlgItem(IDC_MAXDOWN)->SetWindowText("64");
			GetDlgItem(IDC_MAXUP)->SetWindowText("14");
			GetDlgItem(IDC_MAXCON)->SetWindowText("384");
		}
		else if (conprofsel == 3){
			DisableEditBoxes();
			GetDlgItem(IDC_DOWNLOAD_CAP)->SetWindowText("64");
			GetDlgItem(IDC_UPLOAD_CAP)->SetWindowText("32");
			GetDlgItem(IDC_MAXDOWN)->SetWindowText("64");
			GetDlgItem(IDC_MAXUP)->SetWindowText("30");
			GetDlgItem(IDC_MAXCON)->SetWindowText("384");
		}
		else if (conprofsel == 4){
			DisableEditBoxes();
			GetDlgItem(IDC_DOWNLOAD_CAP)->SetWindowText("96");
			GetDlgItem(IDC_UPLOAD_CAP)->SetWindowText("16");
			GetDlgItem(IDC_MAXDOWN)->SetWindowText("96");
			GetDlgItem(IDC_MAXUP)->SetWindowText("14");
			GetDlgItem(IDC_MAXCON)->SetWindowText("512");
		}
		else if (conprofsel == 5){
			DisableEditBoxes();
			GetDlgItem(IDC_DOWNLOAD_CAP)->SetWindowText("128");
			GetDlgItem(IDC_UPLOAD_CAP)->SetWindowText("32");
			GetDlgItem(IDC_MAXDOWN)->SetWindowText("128");
			GetDlgItem(IDC_MAXUP)->SetWindowText("30");
			GetDlgItem(IDC_MAXCON)->SetWindowText("768");
		}
		else if (conprofsel == 6){
			DisableEditBoxes();
			GetDlgItem(IDC_DOWNLOAD_CAP)->SetWindowText("128");
			GetDlgItem(IDC_UPLOAD_CAP)->SetWindowText("64");
			GetDlgItem(IDC_MAXDOWN)->SetWindowText("128");
			GetDlgItem(IDC_MAXUP)->SetWindowText("60");
			GetDlgItem(IDC_MAXCON)->SetWindowText("1024");
		}
		else if (conprofsel == 7){
			DisableEditBoxes();
			GetDlgItem(IDC_DOWNLOAD_CAP)->SetWindowText("128");
			GetDlgItem(IDC_UPLOAD_CAP)->SetWindowText("48");
			GetDlgItem(IDC_MAXDOWN)->SetWindowText("128");
			GetDlgItem(IDC_MAXUP)->SetWindowText("44");
			GetDlgItem(IDC_MAXCON)->SetWindowText("1024");
		}
		else if (conprofsel == 8){
			DisableEditBoxes();
			GetDlgItem(IDC_DOWNLOAD_CAP)->SetWindowText("180");
			GetDlgItem(IDC_UPLOAD_CAP)->SetWindowText("180");
			GetDlgItem(IDC_MAXDOWN)->SetWindowText("180");
			GetDlgItem(IDC_MAXUP)->SetWindowText("180");
			GetDlgItem(IDC_MAXCON)->SetWindowText("2048");
		}
		else if (conprofsel == 9){
			DisableEditBoxes();
			GetDlgItem(IDC_DOWNLOAD_CAP)->SetWindowText("5");
			GetDlgItem(IDC_UPLOAD_CAP)->SetWindowText("2");
			GetDlgItem(IDC_MAXDOWN)->SetWindowText("5");
			GetDlgItem(IDC_MAXUP)->SetWindowText("2");
			GetDlgItem(IDC_MAXCON)->SetWindowText("5");
		}
		else if (conprofsel == 10){
			DisableEditBoxes();
			GetDlgItem(IDC_DOWNLOAD_CAP)->SetWindowText("8");
			GetDlgItem(IDC_UPLOAD_CAP)->SetWindowText("8");
			GetDlgItem(IDC_MAXDOWN)->SetWindowText("8");
			GetDlgItem(IDC_MAXUP)->SetWindowText("6");
			GetDlgItem(IDC_MAXCON)->SetWindowText("20");
		}
		else if (conprofsel == 11){
			DisableEditBoxes();
			GetDlgItem(IDC_DOWNLOAD_CAP)->SetWindowText("16");
			GetDlgItem(IDC_UPLOAD_CAP)->SetWindowText("16");
			GetDlgItem(IDC_MAXDOWN)->SetWindowText("16");
			GetDlgItem(IDC_MAXUP)->SetWindowText("14");
			GetDlgItem(IDC_MAXCON)->SetWindowText("50");
		}
	}
}

void CPPgConnection::DisableEditBoxes(void){
		CEdit* DwnCap;
		DwnCap = (CEdit*) GetDlgItem(IDC_DOWNLOAD_CAP);
		DwnCap->EnableWindow(FALSE);	
		CEdit* UpCap;
		UpCap = (CEdit*) GetDlgItem(IDC_UPLOAD_CAP);
		UpCap->EnableWindow(FALSE);	
		CEdit* MaxDwn;
		MaxDwn = (CEdit*) GetDlgItem(IDC_MAXDOWN);
		MaxDwn->EnableWindow(FALSE);	
		CEdit* MaxUp;
		MaxUp = (CEdit*) GetDlgItem(IDC_MAXUP);
		MaxUp->EnableWindow(FALSE);	
		CEdit* MaxCon;
		MaxCon = (CEdit*) GetDlgItem(IDC_MAXCON);
		MaxCon->EnableWindow(FALSE);
}

void CPPgConnection::EnableEditBoxes(void){
		CEdit* DwnCap;
		DwnCap = (CEdit*) GetDlgItem(IDC_DOWNLOAD_CAP);
		DwnCap->EnableWindow(TRUE);	
		CEdit* UpCap;
		UpCap = (CEdit*) GetDlgItem(IDC_UPLOAD_CAP);
		UpCap->EnableWindow(TRUE);	
		CEdit* MaxDwn;
		MaxDwn = (CEdit*) GetDlgItem(IDC_MAXDOWN);
		MaxDwn->EnableWindow(TRUE);	
		CEdit* MaxUp;
		MaxUp = (CEdit*) GetDlgItem(IDC_MAXUP);
		MaxUp->EnableWindow(TRUE);	
		CEdit* MaxCon;
		MaxCon = (CEdit*) GetDlgItem(IDC_MAXCON);
		MaxCon->EnableWindow(TRUE);
}

void CPPgConnection::OnBnClickedDisableXS()
{
	CString str;
	if (IsDlgButtonChecked(IDC_DISABLE_XS))
	{
		str.Format("%u", 200);
		GetDlgItem(IDC_ENABLE_XSUPTO)->EnableWindow(!IsDlgButtonChecked(IDC_DISABLE_XS));
		GetDlgItem(IDC_XSUPTO)->EnableWindow(!IsDlgButtonChecked(IDC_DISABLE_XS));
	} else {
		str.Format("%u", 100);
		GetDlgItem(IDC_ENABLE_XSUPTO)->EnableWindow(!IsDlgButtonChecked(IDC_DISABLE_XS));
		if (!IsDlgButtonChecked(IDC_DISABLE_XS) && IsDlgButtonChecked(IDC_ENABLE_XSUPTO))
			GetDlgItem(IDC_XSUPTO)->EnableWindow(IsDlgButtonChecked(IDC_ENABLE_XSUPTO));
		else
			GetDlgItem(IDC_XSUPTO)->EnableWindow(IsDlgButtonChecked(IDC_ENABLE_XSUPTO));
	}
	SetModified();
}

void CPPgConnection::OnQueueChange()
{
		char buffer[500];
		uint16 num;
		GetDlgItem(IDC_QUEUESIZE)->GetWindowText(buffer, 20) ;
		num=(atoi(buffer));
		if (num > MAX_QUEUE)
			num=MAX_QUEUE;
		if (num < MIN_QUEUE)
			num=MIN_QUEUE;
		m_RQLimit=(num<2000)?2000:num;			//minimum possible remotequeuelimit
		sprintf(buffer,GetResString(IDS_REMOTEQUEUELIMIT),m_RQLimit);
		GetDlgItem(IDC_LIMITQR)->SetWindowText(buffer);
		if(num!=app_prefs->GetQueueSize())
		{
			sprintf(buffer, "%d",num);
			GetDlgItem(IDC_QUEUESIZE)->SetWindowText(buffer);
		}
}

void CPPgConnection::OnSpeedChange()
{
	int num1, num2, maxDown;
	CString strBuffer;
	char buffer[30];
	num1=app_prefs->GetMaxGraphDownloadRate();
	if(GetDlgItem(IDC_DOWNLOAD_CAP)->GetWindowTextLength())
	{ 
		GetDlgItem(IDC_DOWNLOAD_CAP)->GetWindowText(buffer,20);
		num1= (atoi(buffer)) ? atoi(buffer) : 100;
	}
	strBuffer.Format("%d", num1);
	GetDlgItem(IDC_DOWNLOAD_CAP)->SetWindowText(strBuffer);

	num2=app_prefs->GetMaxDownloadValue();
	if(GetDlgItem(IDC_MAXDOWN)->GetWindowTextLength())
	{
		GetDlgItem(IDC_MAXDOWN)->GetWindowText(buffer,20);
		num2=(atoi(buffer)) ? atoi(buffer) : UNLIMITED;
	}
	maxDown= (num2>num1)?num1:num2;		//Cax2 - used at the end of the function

	num1=app_prefs->GetMaxGraphUploadRate();
	if(GetDlgItem(IDC_UPLOAD_CAP)->GetWindowTextLength())
	{
		GetDlgItem(IDC_UPLOAD_CAP)->GetWindowText(buffer,20);
		num1= (atoi(buffer)) ? atoi(buffer) : 25;
	}
	strBuffer.Format("%d", num1);
	GetDlgItem(IDC_UPLOAD_CAP)->SetWindowText(strBuffer);

	num2=app_prefs->GetMaxUpload();
	if(GetDlgItem(IDC_MAXUP)->GetWindowTextLength())
	{
		GetDlgItem(IDC_MAXUP)->GetWindowText(buffer,20);
		num2=(atoi(buffer)) ? atoi(buffer) : UNLIMITED;
	}
	num2= (num2>num1)?num1:num2;
	strBuffer.Format("%d", num2);
	GetDlgItem(IDC_MAXUP)->SetWindowText(strBuffer);

	if(num2 < 4)
		maxDown=(num2*3 < maxDown)?num2*3:maxDown;
	if( num2 < 10)
		maxDown=(num2*4 <maxDown)?num2*4:maxDown;
	strBuffer.Format("%d", maxDown);
	GetDlgItem(IDC_MAXDOWN)->SetWindowText(strBuffer);

}


void CPPgConnection::OnEnChangeUDPDisable()
{
	GetDlgItem(IDC_UDPPORT)->EnableWindow(!IsDlgButtonChecked(IDC_UDPDISABLE));

	if(!IsDlgButtonChecked(IDC_UDPDISABLE) && app_prefs->GetUDPPort()==0) 
	{
			uint16 tempVal=0;
			CString strBuffer;
			char buffer[30];

			if(GetDlgItem(IDC_PORT)->GetWindowTextLength())
			{
				GetDlgItem(IDC_PORT)->GetWindowText(buffer,20);
				tempVal= (atoi(buffer)) ? atoi(buffer)+10 : app_prefs->GetPort()+10;
			}
			strBuffer.Format("%d", tempVal);
			GetDlgItem(IDC_UDPPORT)->SetWindowText(strBuffer);
	}

	SetModified();
}

void CPPgConnection::OnBnClickedDisableXSUpTo()
{
	GetDlgItem(IDC_XSUPTO)->EnableWindow(IsDlgButtonChecked(IDC_ENABLE_XSUPTO));

	SetModified();
}