//--- xrmb:partTrafficPrefs ---

// PgTweaks.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgModPt.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// CPPgModPT dialog

IMPLEMENT_DYNAMIC(CPPgModPT, CPropertyPage)

CPPgModPT::CPPgModPT()
	: CPropertyPage(CPPgModPT::IDD)
{
}

CPPgModPT::~CPPgModPT()
{
}

void CPPgModPT::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CPPgModPT, CPropertyPage)
	ON_BN_CLICKED(IDC_UPBARST1, OnBnClickedUpbarst1)
	ON_BN_CLICKED(IDC_UPBARST2, OnBnClickedUpbarst2)
	ON_BN_CLICKED(IDC_UPBARST3, OnBnClickedUpbarst3)
	ON_BN_CLICKED(IDC_UPBARST4, OnBnClickedUpbarst4)
	ON_BN_CLICKED(IDC_UPBARCL1, OnBnClickedUpbarcl1)
	ON_BN_CLICKED(IDC_UPBARCL2, OnBnClickedUpbarcl2)
	ON_BN_CLICKED(IDC_UPBARCL3, OnBnClickedUpbarcl3)
	ON_BN_CLICKED(IDC_UPBARCL4, OnBnClickedUpbarcl4)
	ON_BN_CLICKED(IDC_PT_USEIT, OnBnClickedPtUseit)
	ON_BN_CLICKED(IDC_UPLOADPARTS, OnBnClickedUploadParts)
END_MESSAGE_MAP()


// CPPgModPT message handlers


BOOL CPPgModPT::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgModPT::LoadSettings(void)
{
	if(m_hWnd)
	{
		CheckDlgButton(IDC_PT_USEIT,(app_prefs->DoUsePT())?1:0); // Cax2 05/01/03

		switch(app_prefs->GetUpbarStyle())
		{
			case 1:  this->CheckDlgButton(IDC_UPBARST2,1); break;
			case 2:	 this->CheckDlgButton(IDC_UPBARST3,1); break;
			case 3:	 this->CheckDlgButton(IDC_UPBARST4,1); break;
			default: this->CheckDlgButton(IDC_UPBARST1,1); break;
		}
		
		switch(app_prefs->GetUpbarColor())
		{
			case 1:  this->CheckDlgButton(IDC_UPBARCL2,1); break;
			case 2:  this->CheckDlgButton(IDC_UPBARCL3,1); break;
			case 3:  this->CheckDlgButton(IDC_UPBARCL4,1); break;
			default: this->CheckDlgButton(IDC_UPBARCL1,1); break;
		}

        //Cax2 re-enabled toggle progress bars
		CheckDlgButton(IDC_UPLOADPARTS,(app_prefs->IsUploadPartsEnabled())?1:0);

		OnBnClickedPtUseit();

		SetModified(FALSE);	// FoRcHa
	}
}

BOOL CPPgModPT::OnApply()
{
//	CSingleLock PrefLock(&(app_prefs->m_Pref_Mutex),TRUE); 

	if(m_bModified)
	{
		if(!IsDlgButtonChecked(IDC_PT_USEIT)==app_prefs->DoUsePT())	//Cax2 if we changed it, display/hide column accordingly
		{
			app_prefs->SetUsePT(IsDlgButtonChecked(IDC_PT_USEIT));
			if(app_prefs->DoUsePT())
				theApp.emuledlg->sharedfileswnd.sharedfilesctrl.ShowColumn(9);	//Cax2 part traffic column
			else
				theApp.emuledlg->sharedfileswnd.sharedfilesctrl.HideColumn(9);	//Cax2 part traffic column
		}

		if(IsDlgButtonChecked(IDC_UPBARST1))
			app_prefs->SetUpbarStyle(0);
		else 
		if(IsDlgButtonChecked(IDC_UPBARST2))
			app_prefs->SetUpbarStyle(1);
		else 
		if(IsDlgButtonChecked(IDC_UPBARST3))
			app_prefs->SetUpbarStyle(2);
		else 
		if(IsDlgButtonChecked(IDC_UPBARST4))
			app_prefs->SetUpbarStyle(3);

		if(IsDlgButtonChecked(IDC_UPBARCL1))
			app_prefs->SetUpbarColor(0);
		else 
		if(IsDlgButtonChecked(IDC_UPBARCL2))
			app_prefs->SetUpbarColor(1);
		else 
		if(IsDlgButtonChecked(IDC_UPBARCL3))
			app_prefs->SetUpbarColor(2);
		else 
		if(IsDlgButtonChecked(IDC_UPBARCL4))
			app_prefs->SetUpbarColor(3);

		if(app_prefs->IsUploadPartsEnabled()==!IsDlgButtonChecked(IDC_UPLOADPARTS))		//Cax2 if we changed it, display/hide columns accordingly
		{
			app_prefs->SetUploadPartsEnabled(IsDlgButtonChecked(IDC_UPLOADPARTS));
			if(app_prefs->IsUploadPartsEnabled())
			{
				theApp.emuledlg->transferwnd.uploadlistctrl.ShowColumn(8);		//Cax2 if the progressbar column change change this number
				theApp.emuledlg->transferwnd.queuelistctrl.ShowColumn(4);		
			}
			else
			{
				theApp.emuledlg->transferwnd.uploadlistctrl.HideColumn(8);		//Cax2 if the progressbar column change change this number
				theApp.emuledlg->transferwnd.queuelistctrl.HideColumn(4);		
			}
		}

		OnBnClickedPtUseit();
		
		theApp.emuledlg->sharedfileswnd.sharedfilesctrl.SetDisplay(app_prefs->GetUpbarStyle(), true);
		theApp.emuledlg->sharedfileswnd.sharedfilesctrl.SetColoring(app_prefs->GetUpbarColor());

		LoadSettings();
		SetModified(FALSE);
	}
	return CPropertyPage::OnApply();
}

void CPPgModPT::Localize(void)
{	
	if(m_hWnd)
	{
		GetDlgItem(IDC_PT_USEIT)->SetWindowText(GetResString(IDS_PT_USEIT));
		GetDlgItem(IDC_UPBARST)->SetWindowText(GetResString(IDS_UPBARST));
		GetDlgItem(IDC_UPBARST1)->SetWindowText(GetResString(IDS_UPBARST1));
		GetDlgItem(IDC_UPBARST2)->SetWindowText(GetResString(IDS_UPBARST2));
		GetDlgItem(IDC_UPBARST3)->SetWindowText(GetResString(IDS_UPBARST3));
		GetDlgItem(IDC_UPBARCL)->SetWindowText(GetResString(IDS_UPBARCL));
		GetDlgItem(IDC_UPBARCL1)->SetWindowText(GetResString(IDS_UPBARCL1));
		GetDlgItem(IDC_UPBARCL2)->SetWindowText(GetResString(IDS_UPBARCL2));
		GetDlgItem(IDC_UPBARCL3)->SetWindowText(GetResString(IDS_UPBARCL3));
		GetDlgItem(IDC_UPBARCL4)->SetWindowText(GetResString(IDS_UPBARCL4));
		GetDlgItem(IDC_UPLOADPARTS)->SetWindowText(GetResString(IDS_UPLOADPARTS));
	}
}

void CPPgModPT::OnBnClickedPtUseit()
{
	GetDlgItem(IDC_UPBARST1)->EnableWindow(IsDlgButtonChecked(IDC_PT_USEIT));
	GetDlgItem(IDC_UPBARST2)->EnableWindow(IsDlgButtonChecked(IDC_PT_USEIT));
	GetDlgItem(IDC_UPBARST3)->EnableWindow(IsDlgButtonChecked(IDC_PT_USEIT));
	GetDlgItem(IDC_UPBARST4)->EnableWindow(IsDlgButtonChecked(IDC_PT_USEIT));
	GetDlgItem(IDC_UPBARCL1)->EnableWindow(IsDlgButtonChecked(IDC_PT_USEIT));
	GetDlgItem(IDC_UPBARCL2)->EnableWindow(IsDlgButtonChecked(IDC_PT_USEIT));
	GetDlgItem(IDC_UPBARCL3)->EnableWindow(IsDlgButtonChecked(IDC_PT_USEIT));
	GetDlgItem(IDC_UPBARCL4)->EnableWindow(IsDlgButtonChecked(IDC_PT_USEIT));

	SetModified();
}
